"""Tkinker gui for pylint"""

__revision__ = '$Id: gui.py,v 1.3 2004/02/17 10:16:00 syt Exp $'

from Tkinter import Tk, Frame, Listbox, Entry, Label, Button, Scrollbar
from Tkinter import TOP, LEFT, RIGHT, BOTTOM, END, X, Y, BOTH
import os

class LintGui:
    """Build and control a window to interact with pylint"""
    
    def __init__(self, root=None):
        self.root = root or Tk()
        self.root.title('Pylint')
        topFrame = Frame(self.root)
        resFrame = Frame(self.root)
        btnFrame = Frame(self.root)
        topFrame.pack(side=TOP, fill=X)
        resFrame.pack(side=TOP, fill=BOTH, expand=True)
        btnFrame.pack(side=TOP, fill=X)
        
        Label(topFrame, text='Module or package').pack(side=LEFT)
        self.txtModule = Entry(topFrame, background='white')
        self.txtModule.bind('<Return>', self.runLint)
        self.txtModule.pack(side=LEFT, expand=True, fill=X)
        Button(topFrame, text='Run', command=self.runLint).pack(side=LEFT)

        scrl = Scrollbar(resFrame)
        self.results = Listbox(resFrame,
                               background='white',
                               font='fixed',
                               selectmode='browse',
                               yscrollcommand=scrl.set)
        scrl.configure(command=self.results.yview)
        self.results.pack(side=LEFT, expand=True, fill=BOTH)
        scrl.pack(side=RIGHT, fill=Y)
        
        
        Button(btnFrame, text='Quit', command=self.quit).pack(side=BOTTOM)
        #self.root.bind('<ctrl-q>', self.quit)
        self.txtModule.focus_set()
        
    def mainloop(self):
        """lauch the mainloop of the application"""
        self.root.mainloop()

    def quit(self, event=None):
        """quit the application"""
        self.root.quit()

    def runLint(self, event=None):
        """lauches pylint"""
        colors = {'W:':'red1', 'E:': 'red4',
                  'W:': 'red3', '**': 'navy'}
        
        self.root.configure(cursor='watch')
        self.results.focus_set()
        self.results.delete(0, END)
        self.results.update()
        module = self.txtModule.get()
        pout = os.popen('pylint %s'%module,'r')
        for line in  pout.xreadlines():
            line = line.rstrip()
            self.results.insert(END, line)
            fg_color = colors.get(line[:2],'black')
            self.results.itemconfigure(END, fg=fg_color)
            self.results.update()
        self.root.configure(cursor='')

def Run(args):
    gui = LintGui()
    gui.mainloop()

if __name__ == '__main__':
    import sys
    Run(sys.argv[1:]) 
