# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
""" Copyright (c) 2000-2003 LOGILAB S.A. (Paris, FRANCE).
 http://www.logilab.fr/ -- mailto:contact@logilab.fr

Miscellaneous unit tests
"""

__revision__ = '$Id: unittest_misc.py,v 1.1 2003/09/10 06:37:21 syt Exp $'

import unittest
import re

from logilab.pylint.checkers.format import pretty_match

class PrettymatchFunctionTest(unittest.TestCase):

    def test_known_values_1(self):
        rgx = re.compile('(to*)')
        string = 'toto'
        match = rgx.search(string)
        self.assertEqual(pretty_match(match, string), '''toto
^^''')
        
    def test_known_values_2(self):
        rgx = re.compile('(to*)')
        string = '''
... ... to to
... ... '''
        match = rgx.search(string)
        self.assertEqual(pretty_match(match, string), '''
... ... to to
        ^^
... ... ''')
        
        

def suite():
    return unittest.makeSuite(PrettymatchFunctionTest)


if __name__=='__main__':
    unittest.main(defaultTest='suite')
